package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringReader;

import javax.servlet.http.HttpServletResponse;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.EntityMarshaller;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.EntityResponseWriter;

import org.apache.commons.io.IOUtils;

public class EntityResponseWriterImpl implements EntityResponseWriter {
    
    public void writeEntityTo(HttpServletResponse response, Object entity) throws IOException {
        String xml = entityMarshaller.marshal(entity);
        response.setContentType("text/xml");
        response.setCharacterEncoding("UTF-8");
        PrintWriter writer = response.getWriter();
        IOUtils.copy(new StringReader(xml), writer);
        writer.flush();
    }
    
    private EntityMarshaller entityMarshaller;
    public void setEntityMarshaller(EntityMarshaller entityMarshaller) {
        this.entityMarshaller = entityMarshaller;
    }
}
